/* 
       Socket Limiter - For pawq.eu.org - No more clones
       crashev <crashev@ebox.pl>

*/

#include <netinet/in.h>
#include <sys/types.h>
#include <linux/unistd.h>
#include <stdio.h>

#include <string.h>
#include <stdlib.h>

#include <errno.h>
#include <dirent.h>

#define __USE_GNU
#include <dlfcn.h>



#define UIDFILE "/var/socklimit/uidfile"
#define MAX         5
#define REVERSE     0

int (*rsocket)(int,int,int)=NULL;

int ile=0;

extern int errno;
int socket(int domain, int type, int protocol) 
	{
         FILE *f;
	 char buf[255];
	 int u=0;
	 int ret=0,r=0;
if (rsocket == NULL)
        rsocket = dlsym(RTLD_NEXT, "socket");

errno=0;
if (!getuid()) return rsocket(domain,type,protocol);
if (getuid()) 
{
/* Config file */
   f=fopen(UIDFILE,"r");
   if (!f) 
      {
                errno=0;
		return rsocket(domain,type,protocol);
      } 
      else 
      {
          while (fgets(buf,sizeof(buf)-1,f)) 
	   {
	       if ( (atoi(buf)==getuid())||(atoi(buf)==getgid()) ) {u=1;break;}
               bzero(buf,sizeof(buf));
           }
       fclose(f);
   }
if (u==1) 
    {   
    if ((ile<MAX)&&((domain==PF_INET)||(domain==PF_INET6))&&(type==SOCK_STREAM))  ile++;
       if ((ile>=MAX)&&(!REVERSE)) 
	{
          errno=13;
          return -1;
        }
     } else if ((REVERSE==1)&&(u==0)) 
     {
if ((ile<MAX)&&((domain==PF_INET)||(domain==PF_INET6))&&(type==SOCK_STREAM))  ile++;
       if (ile>=MAX) 
	{
          errno=13;
          return -1;
        }
      }

}
 ret=rsocket(domain,type,protocol);
 if (ret==-1) ile--;
 return ret;
}


int close(int fd) {
    struct sockaddr_in sck;
    int len,typ;
    len=sizeof(sck);
if (!getsockname(fd,(struct sockaddr_in *)&sck,&len)) 
    {
        len=sizeof(typ);
        getsockopt(fd,SOL_SOCKET,SO_TYPE,&typ,&len);
        if (((sck.sin_family==PF_INET)||(sck.sin_family==PF_INET6))&&(typ==SOCK_STREAM)) ile--;
    }
    return __close(fd);
} 

      